// ***************************************
// BoostC Header file for PIC16F690
// Author(s): David Hobday
//
// Copyright(C) 2003-2007 Pavel Baranov
// Copyright(C) 2003-2007 David Hobday
// All Rights Reserved
// ***************************************


////////////////////////////////////////////////////////////////////////////
//
//       Register Definitions
//
////////////////////////////////////////////////////////////////////////////

#define W                     0x0000 
#define F                     0x0001 

/////// Register Files//////////////////////////////////////////////////////
#define INDF                  0x0000 
#define TMR0                  0x0001 
#define PCL                   0x0002 
#define STATUS                0x0003 
#define FSR                   0x0004 
#define PORTA                 0x0005 
#define PORTB                 0x0006 
#define PORTC                 0x0007 
#define PCLATH                0x000A 
#define INTCON                0x000B 
#define PIR1                  0x000C 
#define PIR2                  0x000D 
#define TMR1L                 0x000E 
#define TMR1H                 0x000F 
#define T1CON                 0x0010 
#define TMR2                  0x0011 
#define T2CON                 0x0012 
#define SSPBUF                0x0013 
#define SSPCON                0x0014 
#define CCPR1L                0x0015 
#define CCPR1H                0x0016 
#define CCP1CON               0x0017 
#define RCSTA                 0x0018 
#define TXREG                 0x0019 
#define RCREG                 0x001A 
#define PWM1CON               0x001C 
#define ECCPAS                0x001D 
#define ADRESH                0x001E 
#define ADCON0                0x001F 
#define OPTION_REG            0x0081 
#define TRISA                 0x0085 
#define TRISB                 0x0086 
#define TRISC                 0x0087 
#define PIE1                  0x008C 
#define PIE2                  0x008D 
#define PCON                  0x008E 
#define OSCCON                0x008F 
#define OSCTUNE               0x0090 
#define PR2                   0x0092 
#define SSPADD                0x0093 
#define MSK                   0x0093 
#define SSPMSK                0x0093 
#define SSPSTAT               0x0094 
#define WPU                   0x0095 
#define WPUA                  0x0095 
#define IOC                   0x0096 
#define IOCA                  0x0096 
#define WDTCON                0x0097 
#define TXSTA                 0x0098 
#define SPBRG                 0x0099 
#define SPBRGH                0x009A 
#define BAUDCTL               0x009B 
#define ADRESL                0x009E 
#define ADCON1                0x009F 
#define EEDAT                 0x010C 
#define EEDATA                0x010C 
#define EEADR                 0x010D 
#define EEDATH                0x010E 
#define EEADRH                0x010F 
#define WPUB                  0x0115 
#define IOCB                  0x0116 
#define VRCON                 0x0118 
#define CM1CON0               0x0119 
#define CM2CON0               0x011A 
#define CM2CON1               0x011B 
#define ANSEL                 0x011E 
#define ANSELH                0x011F 
#define EECON1                0x018C 
#define EECON2                0x018D 
#define PSTRCON               0x019D 
#define SRCON                 0x019E 

/////// BANK 0 REGISTER DEFINITIONS ////////////////////////////////////////

/////// STATUS Bits ////////////////////////////////////////////////////////
#define IRP                   0x0007 
#define RP1                   0x0006 
#define RP0                   0x0005 
#define NOT_TO                0x0004 
#define NOT_PD                0x0003 
#define Z                     0x0002 
#define DC                    0x0001 
#define C                     0x0000 

/////// INTCON Bits ////////////////////////////////////////////////////////
#define GIE                   0x0007 
#define PEIE                  0x0006 
#define T0IE                  0x0005 
#define INTE                  0x0004 
#define RABIE                 0x0003 
#define T0IF                  0x0002 
#define INTF                  0x0001 
#define RABIF                 0x0000 

/////// PIR1 Bits //////////////////////////////////////////////////////////
#define ADIF                  0x0006 
#define RCIF                  0x0005 
#define TXIF                  0x0004 
#define SSPIF                 0x0003 
#define CCP1IF                0x0002 
#define T2IF                  0x0001 
#define TMR2IF                0x0001 
#define T1IF                  0x0000 
#define TMR1IF                0x0000 

/////// PIR2 Bits //////////////////////////////////////////////////////////
#define OSFIF                 0x0007 
#define C2IF                  0x0006 
#define C1IF                  0x0005 
#define EEIF                  0x0004 

/////// T1CON Bits /////////////////////////////////////////////////////////
#define T1GINV                0x0007 
#define TMR1GE                0x0006 
#define T1CKPS1               0x0005 
#define T1CKPS0               0x0004 
#define T1OSCEN               0x0003 
#define NOT_T1SYNC            0x0002 
#define TMR1CS                0x0001 
#define TMR1ON                0x0000 

/////// T2CON Bits /////////////////////////////////////////////////////////
#define TOUTPS3               0x0006 
#define TOUTPS2               0x0005 
#define TOUTPS1               0x0004 
#define TOUTPS0               0x0003 
#define TMR2ON                0x0002 
#define T2CKPS1               0x0001 
#define T2CKPS0               0x0000 

/////// SSPCON Bits ///////////////////////////////////////////////////////
#define WCOL                  0x0007 
#define SSPOV                 0x0006 
#define SSPEN                 0x0005 
#define CKP                   0x0004 
#define SSPM3                 0x0003 
#define SSPM2                 0x0002 
#define SSPM1                 0x0001 
#define SSPM0                 0x0000 

/////// CCP1CON Bits ///////////////////////////////////////////////////////
#define P1M1                  0x0007 
#define P1M0                  0x0006 
#define DC1B1                 0x0005 
#define DC1B0                 0x0004 
#define CCP1M3                0x0003 
#define CCP1M2                0x0002 
#define CCP1M1                0x0001 
#define CCP1M0                0x0000 

/////// RCSTA Bits /////////////////////////////////////////////////////////
#define SPEN                  0x0007 
#define RX9                   0x0006 
#define SREN                  0x0005 
#define CREN                  0x0004 
#define ADDEN                 0x0003 
#define FERR                  0x0002 
#define OERR                  0x0001 
#define RX9D                  0x0000 

/////// PWM1CON Bits ///////////////////////////////////////////////////////
#define PRSEN                 0x0007 
#define PDC6                  0x0006 
#define PDC5                  0x0005 
#define PDC4                  0x0004 
#define PDC3                  0x0003 
#define PDC2                  0x0002 
#define PDC1                  0x0001 
#define PDC0                  0x0000 

/////// ECCPAS Bits ////////////////////////////////////////////////////////
#define ECCPASE               0x0007 
#define ECCPAS2               0x0006 
#define ECCPAS1               0x0005 
#define ECCPAS0               0x0004 
#define PSSAC1                0x0003 
#define PSSAC0                0x0002 
#define PSSBD1                0x0001 
#define PSSBD0                0x0000 

/////// ADCON0 Bits ////////////////////////////////////////////////////////
#define ADFM                  0x0007 
#define VCFG                  0x0006 
#define CHS3                  0x0005 
#define CHS2                  0x0004 
#define CHS1                  0x0003 
#define CHS0                  0x0002 
#define GO                    0x0001 
#define NOT_DONE              0x0001 
#define GO_DONE               0x0001 
#define ADON                  0x0000 

/////// BANK 1 REGISTER DEFINITIONS ////////////////////////////////////////

/////// OPTION Bits ////////////////////////////////////////////////////////
#define NOT_RABPU             0x0007 
#define INTEDG                0x0006 
#define T0CS                  0x0005 
#define T0SE                  0x0004 
#define PSA                   0x0003 
#define PS2                   0x0002 
#define PS1                   0x0001 
#define PS0                   0x0000 

/////// TRISA Bits ////////////////////////////////////////////////////////
#define TRISA5                0x0005 
#define TRISA4                0x0004 
#define TRISA3                0x0003 
#define TRISA2                0x0002 
#define TRISA1                0x0001 
#define TRISA0                0x0000 

/////// TRISB Bits ////////////////////////////////////////////////////////
#define TRISB7                0x0007 
#define TRISB6                0x0006 
#define TRISB5                0x0005 
#define TRISB4                0x0004 

/////// TRISC Bits ////////////////////////////////////////////////////////
#define TRISC7                0x0007 
#define TRISC6                0x0006 
#define TRISC5                0x0005 
#define TRISC4                0x0004 
#define TRISC3                0x0003 
#define TRISC2                0x0002 
#define TRISC1                0x0001 
#define TRISC0                0x0000 

/////// PIE1 Bits //////////////////////////////////////////////////////////
#define ADIE                  0x0006 
#define RCIE                  0x0005 
#define TXIE                  0x0004 
#define SSPIE                 0x0003 
#define CCP1IE                0x0002 
#define T2IE                  0x0001 
#define TMR2IE                0x0001 
#define T1IE                  0x0000 
#define TMR1IE                0x0000 

/////// PIE2 Bits //////////////////////////////////////////////////////////
#define OSFIE                 0x0007 
#define C2IE                  0x0006 
#define C1IE                  0x0005 
#define EEIE                  0x0004 

/////// PCON Bits //////////////////////////////////////////////////////////
#define ULPWUE                0x0005 
#define SBOREN                0x0004 
#define NOT_POR               0x0001 
#define NOT_BOR               0x0000 

/////// OSCCON Bits ////////////////////////////////////////////////////////
#define IRCF2                 0x0006 
#define IRCF1                 0x0005 
#define IRCF0                 0x0004 
#define OSTS                  0x0003 
#define HTS                   0x0002 
#define LTS                   0x0001 
#define SCS                   0x0000 

/////// OSCTUNE Bits ///////////////////////////////////////////////////////
#define TUN4                  0x0004 
#define TUN3                  0x0003 
#define TUN2                  0x0002 
#define TUN1                  0x0001 
#define TUN0                  0x0000 

/////// SSPSTAT Bits ////////////////////////////////////////////////////////
#define SMP                   0x0007 
#define CKE                   0x0006 
#define D                     0x0005 
#define I2C_DATA              0x0005 
#define NOT_A                 0x0005 
#define NOT_ADDRESS           0x0005 
#define D_A                   0x0005 
#define DATA_ADDRESS          0x0005 
#define P                     0x0004 
#define I2C_STOP              0x0004 
#define S                     0x0003 
#define I2C_START             0x0003 
#define R                     0x0002 
#define I2C_READ              0x0002 
#define NOT_W                 0x0002 
#define NOT_WRITE             0x0002 
#define R_W                   0x0002 
#define READ_WRITE            0x0002 
#define UA                    0x0001 
#define BF                    0x0000 

/////// WPUA //////////////////////////////////////////////////////////////
#define WPUA5                 0x0005 
#define WPUA4                 0x0004 
#define WPUA2                 0x0002 
#define WPUA1                 0x0001 
#define WPUA0                 0x0000 

/////// IOC //////////////////////////////////////////////////////////////
#define IOC5                  0x0005 
#define IOC4                  0x0004 
#define IOC3                  0x0003 
#define IOC2                  0x0002 
#define IOC1                  0x0001 
#define IOC0                  0x0000 

/////// IOCA //////////////////////////////////////////////////////////////
#define IOCA5                 0x0005 
#define IOCA4                 0x0004 
#define IOCA3                 0x0003 
#define IOCA2                 0x0002 
#define IOCA1                 0x0001 
#define IOCA0                 0x0000 

/////// WDTCON Bits ////////////////////////////////////////////////////////
#define WDTPS3                0x0004 
#define WDTPS2                0x0003 
#define WDTPS1                0x0002 
#define WDTPS0                0x0001 
#define SWDTEN                0x0000 

/////// TXSTA Bits ///////////////////////////////////////////////////////
#define CSRC                  0x0007 
#define TX9                   0x0006 
#define TXEN                  0x0005 
#define SYNC                  0x0004 
#define SENB                  0x0003 
#define BRGH                  0x0002 
#define TRMT                  0x0001 
#define TX9D                  0x0000 

/////// SPBRG Bits ///////////////////////////////////////////////////////
#define BRG7                  0x0007 
#define BRG6                  0x0006 
#define BRG5                  0x0005 
#define BRG4                  0x0004 
#define BRG3                  0x0003 
#define BRG2                  0x0002 
#define BRG1                  0x0001 
#define BRG0                  0x0000 

/////// SPBRGH Bits ///////////////////////////////////////////////////////
#define BRG15                 0x0007 
#define BRG14                 0x0006 
#define BRG13                 0x0005 
#define BRG12                 0x0004 
#define BRG11                 0x0003 
#define BRG10                 0x0002 
#define BRG9                  0x0001 
#define BRG8                  0x0000 

/////// BAUDCTL Bits ///////////////////////////////////////////////////////
#define ABDOVF                0x0007 
#define RCIDL                 0x0006 
#define SCKP                  0x0004 
#define BRG16                 0x0003 
#define WUE                   0x0001 
#define ABDEN                 0x0000 

/////// ADCON1 /////////////////////////////////////////////////////////////
#define ADCS2                 0x0006 
#define ADCS1                 0x0005 
#define ADCS0                 0x0004 

/////// BANK 2 REGISTER DEFINITIONS ////////////////////////////////////////

/////// WPUB Bits //////////////////////////////////////////////////////////
#define WPUB7                 0x0007 
#define WPUB6                 0x0006 
#define WPUB5                 0x0005 
#define WPUB4                 0x0004 

/////// IOCB //////////////////////////////////////////////////////////////
#define IOCB7                 0x0007 
#define IOCB6                 0x0006 
#define IOCB5                 0x0005 
#define IOCB4                 0x0004 

/////// VRCON Bits /////////////////////////////////////////////////////////
#define C1VREN                0x0007 
#define C2VREN                0x0006 
#define VRR                   0x0005 
#define VP6EN                 0x0004 
#define VR3                   0x0003 
#define VR2                   0x0002 
#define VR1                   0x0001 
#define VR0                   0x0000 

/////// CM1CON0 Bits ///////////////////////////////////////////////////////
#define C1ON                  0x0007 
#define C1OUT                 0x0006 
#define C1OE                  0x0005 
#define C1POL                 0x0004 
#define C1R                   0x0002 
#define C1CH1                 0x0001 
#define C1CH0                 0x0000 

/////// CM2CON0 Bits ///////////////////////////////////////////////////////
#define C2ON                  0x0007 
#define C2OUT                 0x0006 
#define C2OE                  0x0005 
#define C2POL                 0x0004 
#define C2R                   0x0002 
#define C2CH1                 0x0001 
#define C2CH0                 0x0000 

/////// CM2CON1 Bits ///////////////////////////////////////////////////////
#define MC1OUT                0x0007 
#define MC2OUT                0x0006 
#define T1GSS                 0x0001 
#define C2SYNC                0x0000 

/////// ANSELH /////////////////////////////////////////////////////////////
#define ANS11                 0x0003 
#define ANS10                 0x0002 
#define ANS9                  0x0001 
#define ANS8                  0x0000 

/////// ANSEL //////////////////////////////////////////////////////////////
#define ANS7                  0x0007 
#define ANS6                  0x0006 
#define ANS5                  0x0005 
#define ANS4                  0x0004 
#define ANS3                  0x0003 
#define ANS2                  0x0002 
#define ANS1                  0x0001 
#define ANS0                  0x0000 

/////// BANK 3 REGISTER DEFINITIONS ////////////////////////////////////////

/////// EECON1 /////////////////////////////////////////////////////////////
#define EEPGD                 0x0007 
#define WRERR                 0x0003 
#define WREN                  0x0002 
#define WR                    0x0001 
#define RD                    0x0000 

/////// PSTRCON /////////////////////////////////////////////////////////////
#define STRSYNC               0x0004 
#define STRD                  0x0003 
#define STRC                  0x0002 
#define STRB                  0x0001 
#define STRA                  0x0000 

/////// SRCON ///////////////////////////////////////////////////////////////
#define SR1                   0x0007 
#define SR0                   0x0006 
#define C1SEN                 0x0005 
#define C2REN                 0x0004 
#define PULSS                 0x0003 
#define PULSR                 0x0002 

////////////////////////////////////////////////////////////////////////////
//
//       Configuration Bits
//
////////////////////////////////////////////////////////////////////////////

#define _FCMEN_ON             0x3FFF 
#define _FCMEN_OFF            0x37FF 
#define _IESO_ON              0x3FFF 
#define _IESO_OFF             0x3BFF 
#define _BOR_ON               0x3FFF 
#define _BOR_NSLEEP           0x3EFF 
#define _BOR_SBODEN           0x3DFF 
#define _BOR_OFF              0x3CFF 
#define _CPD_ON               0x3F7F 
#define _CPD_OFF              0x3FFF 
#define _CP_ON                0x3FBF 
#define _CP_OFF               0x3FFF 
#define _MCLRE_ON             0x3FFF 
#define _MCLRE_OFF            0x3FDF 
#define _PWRTE_OFF            0x3FFF 
#define _PWRTE_ON             0x3FEF 
#define _WDT_ON               0x3FFF 
#define _WDT_OFF              0x3FF7 
#define _LP_OSC               0x3FF8 
#define _XT_OSC               0x3FF9 
#define _HS_OSC               0x3FFA 
#define _EC_OSC               0x3FFB 
#define _INTRC_OSC_NOCLKOUT   0x3FFC 
#define _INTRC_OSC_CLKOUT     0x3FFD 
#define _EXTRC_OSC_NOCLKOUT   0x3FFE 
#define _EXTRC_OSC_CLKOUT     0x3FFF 
#define _INTOSCIO             0x3FFC 
#define _INTOSC               0x3FFD 
#define _EXTRCIO              0x3FFE 
#define _EXTRC                0x3FFF 

/////////////////////////////////////////////////
// Config Register
/////////////////////////////////////////////////
#define _CONFIG               0x2007

/////////////////////////////////////////////////
// EEPROM Base Address when programing
/////////////////////////////////////////////////
// To initialise EEPROM when a device is programmed
// use #pragma DATA _EEPROM, 12, 34, 56 
#define _EEPROM               0x2100

volatile char indf                   @INDF;
volatile char tmr0                   @TMR0;
volatile char pcl                    @PCL;
volatile char status                 @STATUS;
volatile char fsr                    @FSR;
volatile char porta                  @PORTA;
volatile char portb                  @PORTB;
volatile char portc                  @PORTC;
volatile char pclath                 @PCLATH;
volatile char intcon                 @INTCON;
volatile char pir1                   @PIR1;
volatile char pir2                   @PIR2;
volatile char tmr1l                  @TMR1L;
volatile char tmr1h                  @TMR1H;
volatile char t1con                  @T1CON;
volatile char tmr2                   @TMR2;
volatile char t2con                  @T2CON;
volatile char sspbuf                 @SSPBUF;
volatile char sspcon                 @SSPCON;
volatile char ccpr1l                 @CCPR1L;
volatile char ccpr1h                 @CCPR1H;
volatile char ccp1con                @CCP1CON;
volatile char rcsta                  @RCSTA;
volatile char txreg                  @TXREG;
volatile char rcreg                  @RCREG;
volatile char pwm1con                @PWM1CON;
volatile char eccpas                 @ECCPAS;
volatile char adresh                 @ADRESH;
volatile char adcon0                 @ADCON0;
volatile char option_reg             @OPTION_REG;
volatile char trisa                  @TRISA;
volatile char trisb                  @TRISB;
volatile char trisc                  @TRISC;
volatile char pie1                   @PIE1;
volatile char pie2                   @PIE2;
volatile char pcon                   @PCON;
volatile char osccon                 @OSCCON;
volatile char osctune                @OSCTUNE;
volatile char pr2                    @PR2;
volatile char sspadd                 @SSPADD;
volatile char sspstat                @SSPSTAT;
volatile char wpu                    @WPU;
volatile char ioc                    @IOC;
volatile char wdtcon                 @WDTCON;
volatile char txsta                  @TXSTA;
volatile char spbrg                  @SPBRG;
volatile char spbrgh                 @SPBRGH;
volatile char baudctl                @BAUDCTL;
volatile char adresl                 @ADRESL;
volatile char adcon1                 @ADCON1;
volatile char eedata                 @EEDATA;
volatile char eeadr                  @EEADR;
volatile char eedath                 @EEDATH;
volatile char eeadrh                 @EEADRH;
volatile char wpua                   @WPUA;
volatile char wpub                   @WPUB;
volatile char iocb                   @IOCB;
volatile char vrcon                  @VRCON;
volatile char cm1con0                @CM1CON0;
volatile char cm2con0                @CM2CON0;
volatile char cm2con1                @CM2CON1;
volatile char ansel                  @ANSEL;
volatile char anselh                 @ANSELH;
volatile char eecon1                 @EECON1;
volatile char eecon2                 @EECON2;
volatile char pstrcon                @PSTRCON;
volatile char srcon                  @SRCON;

